var sortCol;												// a tbla ezen oszlop szerint van rendezve
var actTab;													// az aktulis "oldal" azonostja
var ext = new Array("pdf", "doc", "xls", "ppt", "cdr");		// a figyelt kiterjesztsek
var defValue = new Array();									// ebben lesznek a mezk alaprtelmezett rtkei

// a regisztrci mezinek alaprtelmezett rtkei
defValue["lastname"] = "Vezetknv";
defValue["firstname"] = "Keresztnv";
defValue["organization"] = "A szervezet, akit kpvisel";
defValue["email"] = "grjk, nem kldnk spamet";

// ****************************************************************************
// (t)rendezzk a tblt
// ****************************************************************************
function sortTable(column) {
	// megkeressk a tblt, amin dolgoznunk kell
	var table = document.getElementById("sortable");

	// ha csak egy sora van, akkor nem foglalkozunk vele
	if (table.rows.length <= 1) return;						

	var actHead = table.tHead.rows[0].cells[Math.abs(sortCol) - 1];
	if (actHead) {
		actHead.className = actHead.className.replace((sortCol > 0) ? "asc" : "des", "");
	}

	// ha a jelenlegivel azonos oszlopra kattintott, akkor megfordtjuk a rendezst
	sortCol = column * ((column == sortCol) ? -1 : 1);
	
	// kell egy tmb, amibe kigyjtjk a teljes tblatestet
	var newRows = new Array();
	
	// a tmbbe betltjk az sszes cella tartalmt s stlust
	for (var r = 0; r < table.tBodies[0].rows.length; r++) {
		newRows[r] = new Array();
		for (var c = 0; c < table.tBodies[0].rows[r].cells.length; c++) {
			newRows[r][c] = new Object();
			newRows[r][c].value = table.tBodies[0].rows[r].cells[c].innerHTML;
			newRows[r][c].style = table.tBodies[0].rows[r].cells[c].className;
		}
	}

	// a tmbt lerendezzk a sortFn fggvny segtsgvel
	newRows.sort(sortFn);
		
	// a tmb tartalmt visszarjuk a tblatestbe
	for (var r = 0; r < table.tBodies[0].rows.length; r++) {
		for (var c = 0; c < table.tBodies[0].rows[r].cells.length; c++) {
			table.tBodies[0].rows[r].cells[c].innerHTML = newRows[r][c].value;
			table.tBodies[0].rows[r].cells[c].className = newRows[r][c].style;
		}
	}
		
	var newHead = table.tHead.rows[0].cells[Math.abs(sortCol) - 1];
	newHead.className += (sortCol > 0) ? " asc" : " des";
	newHead.firstChild.blur();
}

// egy kis segtsg a sort() metdusnak
function sortFn(a, b) {
	if (Math.abs(sortCol) != 4) {
		var aa = removeAccents(a[Math.abs(sortCol) - 1].value.toLowerCase());
		var bb = removeAccents(b[Math.abs(sortCol) - 1].value.toLowerCase());
	} else {
		var aa = removeAccents(a[3].value.substr(a[3].value.indexOf(">") + 2, 99));
		var bb = removeAccents(b[3].value.substr(b[3].value.indexOf(">") + 2, 99));
	}

	if (aa == bb)
		return 0;
	else
		return ((aa < bb) ? -1 : 1) * ((sortCol < 0) ? -1: 1);
}

function removeAccents(str) {
	// a rendezskor az kezetes betk zavarak, ezrt eltntetjk az kezeteket
	str = str.replace(//g, "a"); str = str.replace(//g, "e"); str = str.replace(//g, "i");
	str = str.replace(//g, "o"); str = str.replace(//g, "o"); str = str.replace(//g, "o");
	str = str.replace(//g, "u"); str = str.replace(//g, "u"); str = str.replace(//g, "u");
	
	str = str.replace(//g, "A"); str = str.replace(//g, "E"); str = str.replace(//g, "I");
	str = str.replace(//g, "O"); str = str.replace(//g, "O"); str = str.replace(//g, "O");
	str = str.replace(//g, "U"); str = str.replace(//g, "U"); str = str.replace(//g, "U");

	return str;
}

// ****************************************************************************
// a "flek" megjelentse/eltntetse
// ****************************************************************************
function showTab(tab) {
	var tabNum = tab.id.replace("_tab", "");
	
	if (actTab != tabNum) {														// ha nem az aktulis flre kattintott
		actTabDiv = document.getElementById("_head" + actTab).parentNode;		// eltntetjk az aktulis fl tartalmt
		actTabDiv.style.display = "none";
		actTabLi = document.getElementById("_tab" + actTab)						// az aktulis fl LI eleme
		actTabLi.className = actTabLi.className.replace(/selected/g, "");		// mr nem aktulis listaelem

		actTab = tabNum;														// mostantl ez lesz az aktulis fl

		actTabDiv = document.getElementById("_head" + actTab).parentNode;
		actTabDiv.style.display = "block";
		document.getElementById("_tab" + actTab).className += " selected";		// az aktulis flnek ms a szne
	}
	
	tab.childNodes[0].blur();													// eldobjuk a kijells kerett
}

// ****************************************************************************
// a szvegbl eltvoltjuk a fjlnevekben nem hasznlhat karaktereket
// ****************************************************************************
function text2file(text) {
	var remove = '.,:;|/*?<>"';

	text = removeAccents(text.toLowerCase());		// kisbetss alaktjuk, s eltvoltjuk az kezeteket
	text = text.replace(/\s/g, "_");				// a szkzket alhzsaokk alaktjuk
	var file = "";									// eltvoltjuk a nemkvnatos karaktereket
	for (c = 0; c < text.length; c++) {
		file += (remove.indexOf(text.substr(c, 1)) == -1 && text.substr(c, 1) != "\\") ? text.substr(c, 1) : "";
	}
	
	return file;	
}

// ****************************************************************************
// a cmsorok kpeinek kezelse
// ****************************************************************************
function loadHeadImg(headImg) {
	headImg.alt = "";					// ha betltdtt a kp, nem kell ALT neki
}

function errorHeadImg(headImg) {
	// valami hiba trtnt
	var head = headImg.parentNode;		// ebben a cmsorban vagyunk
	if (head) {							// az IE egyszer szl nlkl is hibt ad
		head.removeChild(headImg);		// eltvoltjuk a kpet
		head.innerHTML = headImg.alt;	// visszarjuk az eredeti szveget
		headImg = null;					// a memribl trljk a kpobjektumot
	}
}

// ****************************************************************************
// az rlapkezels funckii
// ****************************************************************************

// kijelljk a kontrol csoportjt
function selectControl(obj) {
	// melyik fieldset-ben tallhat a kontrol
	var parentFS = obj.parentNode;
	while (parentFS != null && parentFS.nodeName.toLowerCase() != "fieldset") {
		parentFS = parentFS.parentNode;
	}
	
	// ha megtalltuk, kijelljk
	if (parentFS != null) {
		var fieldsets = document.getElementsByTagName("fieldset");
		
		for (var f = 0; f < fieldsets.length; f++) {
			if (fieldsets[f] == parentFS) {
				if (parentFS.className.indexOf("selected") == -1)
					parentFS.className += " selected";
			} else {
				fieldsets[f].className = fieldsets[f].className.replace(/selected/g, "");
			}
		}
	}
	
	if (obj.type == "text") {
		if (obj.className.indexOf("selected") == -1)
			obj.className += " selected";
		
		if (defValue[obj.name] != null && obj.value == defValue[obj.name]) {
			obj.value = "";
			obj.className = obj.className.replace(/default/g, "");
		}
	}
}

// a kontrol mr nem kijellt
function releaseControl(obj) {
	obj.className = obj.className.replace(/selected/g, "");
	
	if (defValue[obj.name] != null && obj.value.replace(/\s/g,"") == "") {
		obj.value = defValue[obj.name];
		obj.className += " default";
	}
}

// hossz szveges mezk karakterszmllja s -ellenrzje
function textCounter(obj) {
	// megadtak-e maximlis hosszt
	var maxLength = 0;
	if (obj.className) {
		var match = new RegExp(/\bmaxlen(\d{1,4})\b/).exec(obj.className);
		if (match != null) maxLength = parseInt(match[1]);
	}
	
	// ha igen, akkor nem engednk tbbet bevinni
	if (maxLength > 0 && obj.value.length > maxLength) {
		obj.value = obj.value.substr(0, maxLength);
		alert("Tl hossz szveg! (maximum " + maxLength + " karakter)");
	}

	// kirjuk az aktulis karakterszmot
	document.getElementById(obj.id + "_charnum").innerHTML = obj.value.length;
}

// kontrolcsoport kezelse
function jumpNextElem(evt) {
	var evt = evt || window.event;
	var obj = evt.target || evt.srcElement

	// szmot nyomtak s a szveg elrte a maximlis hosszt
	if ((evt.keyCode >= 48 && evt.keyCode <= 57) && obj.value.length == obj.maxLength) {
		// melyik a kvetkez elem
		var pos = obj.id.lastIndexOf("_") + 1;
		var dest = obj.id.substr(0, pos) + (parseInt(obj.id.substr(pos, 3)) + 1)
		
		// ha van ilyen, akkor tvltunk r
		if (document.getElementById(dest))
			document.getElementById(dest).focus();
	}
	
	// Backspace-t vagy balra nyilat nyomtak s res az elem
	if ((evt.keyCode == 8 || evt.keyCode == 37) && obj.value.length == 0) {
		// melyik az elz elem
		var pos = obj.id.lastIndexOf("_") + 1;
		var dest = obj.id.substr(0, pos) + (parseInt(obj.id.substr(pos, 3)) - 1)

		// ha van ilyen, akkor tvltunk r
		if (document.getElementById(dest))
			document.getElementById(dest).focus();
	}
}

// ****************************************************************************
// inicializljuk az oldalt
// ****************************************************************************
function initPage() {
	// az sszes linket tnzzk s belltjuk 
	var links = document.getElementsByTagName("a");
	
	for (var l = 0; l < links.length; l++) {
		if (links[l].hostname != location.hostname) {
			links[l].target = "_blank";
			links[l].className += " out";
		}

		for (e in ext) {
			if (RegExp(eval("/\." + ext[e] + "$/i")).test(links[l].href))
				links[l].className += " " + ext[e];
		}
		
		if (RegExp(/#$/).test(links[l].href))
			links[l].onclick = function() { return false; }
	}

	// vgignzzk az sszes tblt 
	var tables = document.getElementsByTagName("table");
	
	for (var t = 0; t < tables.length; t++) {
		if (tables[t].className.indexOf("zebra") > -1) {
			// becskozzuk a tblt
			for (var b = 0; b < tables[t].tBodies.length; b++) {
				for (var r = 0; r < tables[t].tBodies[0].rows.length; r++) {
					// a pros sorok "even", a pratlanaok "odd" stlust kapnak
					tables[t].tBodies[0].rows[r].className += (r % 2 == 0) ? " even" : " odd";
					
					// kivltjuk a tr:hover-t kt egyszer fggvnnyel
					tables[t].tBodies[0].rows[r].onmouseover = function() { this.className += " activerow"; }
					tables[t].tBodies[0].rows[r].onmouseout  = function() { this.className = this.className.replace(/activerow/g, ""); }
				}
			}
		}
					
		if (tables[t].id == "sortable") {
			// a fejlcre linkeket helyeznk a rendezshez
			for (var c = 0; c < tables[t].tHead.rows[0].cells.length; c++) {
				// ltrehozunk egy j linket
				var newLink = document.createElement("a");
				newLink.href = "javascript:sortTable(" + (c + 1) + ")";
		
				// a linkhez hozzadjuk a cella sszes elemt
				var children = tables[t].tHead.rows[0].cells[c].childNodes;
				for (var n = 0; n < children.length; n++) {
					newLink.appendChild(children[n]);
				}
				
				// az j linket hozzadjuk a cellhoz
				tables[t].tHead.rows[0].cells[c].appendChild(newLink);
			}
		}
	}
	
	// van-e navigtor div a lapon?
	var nav = document.getElementById("navigator");
	if (nav) {
		// ltrehozunk egy j listt
		var list = document.createElement("ul");
		
		var heads = document.getElementById("jobb_panel").getElementsByTagName("h2");
		for (h = 0; h < heads.length; h++) {
			heads[h].id = "_head" + h;											// azonostt adunk a cmsornak
			
			var listelem = document.createElement("li");						// ltrehozunk egy j LI elemet
			listelem.id = "_tab" + h;											// azonostt adunk a linknek
			listelem.innerHTML = '<A href="#">' + heads[h].innerHTML + '</A>';	// kell egy link
			listelem.onclick   = function() { showTab(this); return false; }  	// amire ha kattintanak, vltson flet
			list.appendChild(listelem);											// felfzzk a listra
			
			if (h == 0) {														// az els a kivlasztott
				listelem.className = "selected";
			} else {
				tabDiv = heads[h].parentNode;									// az sszes tbbit eltntetjk
				tabDiv.style.display = "none";
			}
		}
		nav.appendChild(list);													// a listt beillesztjk a DIV-be
		actTab = "0";															// az aktulis "fl" a 0.
	}
	
	// a rsztvevk tbljban az orszgnevek el odatesszk a zszlkat
	if (document.body.id == "resztvevok") {
		var table = document.getElementById("sortable");

		for (var r = 0; r < table.tBodies[0].rows.length; r++) {
			var county = table.tBodies[0].rows[r].cells[3].innerHTML;
			var cocode = "empty";
			
			for (var c = 0; c < country.length; c++) {
				if (country[c][1].toLowerCase() == county.toLowerCase()) {
					cocode = country[c][0].toLowerCase();
					break;
				}
			}
			table.tBodies[0].rows[r].cells[3].innerHTML = '<img src="images/flags/' + cocode + '.gif" alt=""/> ' + county;
		}
	}
		
	// cikkekhez tartalomjegyzket ksztnk
	if (document.body.id == "cikkek") {
		var toc = document.getElementById("tartalom");
		var art = document.getElementById("cikk");
		
		if (toc && art) {
			var tocList = document.createElement("ul");
			var tocLine = 0;
		
			// helyet csinlunk a tartalomnak
			toc.style.width = "210px";
			toc.style.padding = "6px";
			art.style.width = "712px";
			art.style.marginLeft = "220px";
			
			var tocTitle = document.createElement("h1");
			tocTitle.innerHTML = "Tartalom";
			toc.appendChild(tocTitle);
			
			var elems = art.getElementsByTagName("*");
			for (e = 0; e < elems.length; e++) {
				var nodeName = elems[e].nodeName.toLowerCase();
				if (nodeName == "h1" || nodeName == "h2" || nodeName == "h3" || nodeName == "h4") {
					if (elems[e].id) {
						id = elems[e].id
					} else {
						id = "_toc" + ++tocLine;
						elems[e].id = id;
					}

					var tocElem = document.createElement("li");
					tocElem.innerHTML = '<a href="#' + id + '">' + elems[e].innerHTML + '</a>';
					tocElem.className = "toclevel" + nodeName.substr(1, 1);
					tocList.appendChild(tocElem);
				}
			}
			toc.appendChild(tocList);
		}
	}
	
	// cikkek cmsorainak szvegeit kpekre cserljk
	if (document.body.id == "cikkek" && document.body.className) {
		var art = document.getElementById("cikk");
		var imgPath = "images/heads/" + document.body.className + "/";
		
		if (art) {
			var h1s = art.getElementsByTagName("h1");
			var h2s = art.getElementsByTagName("h2");
			var h3s = art.getElementsByTagName("h3");
			
			for (var h = 0; h < h1s.length + h2s.length + h3s.length ; h++) {
				if (h < h1s.length)
					var head = h1s[h];
				else if (h < h1s.length + h2s.length)
					var head = h2s[h - h1s.length];
				else
					var head = h3s[h - h1s.length - h2s.length];
				
				var headImg = document.createElement("img");
				headImg.alt = head.innerHTML;
				headImg.onload  = function() { loadHeadImg(this); };
				headImg.onerror = function() { errorHeadImg(this); };
				headImg.src = imgPath + text2file(head.innerHTML) + ".gif";
						
				head.innerHTML = "";
				
				head.appendChild(headImg);
			}
		}
	}
	
	// inicializljuk regisztrcis rlapot
	if (document.getElementById("registration")) {
		var form = document.getElementById("registration");
		
		// az orszgvlaszt listban a nevek el kitesszk a zszlt
		var optCountries = document.getElementById("country").getElementsByTagName("option");
		
		for (var o = 0; o < optCountries.length; o++) {
			if (optCountries[o].value != null) {
				optCountries[o].style.paddingLeft = "22px";
				optCountries[o].style.backgroundImage = "url(images/flags/" + optCountries[o].value.toLowerCase() + ".gif)";
				optCountries[o].style.backgroundRepeat = "no-repeat";
				optCountries[o].style.backgroundPosition = "0 2px";
			}
		}
		
		// a kijellt kontrolok csoportjt kiemeljk
		var controls = form.getElementsByTagName("select");
		for (var c = 0; c < controls.length; c++)
			controls[c].onfocus = function() { selectControl(this); }

		// emelett a szvegdobozoknl kezeljk az alaprtelmezett rtkeket
		var controls = form.getElementsByTagName("input");
		for (var c = 0; c < controls.length; c++) {
			controls[c].onfocus = function() { selectControl(this); }
			controls[c].onblur = function() { releaseControl(this); }

			// van-e hozztartoz alaprtelmezett rtk
			if (defValue[controls[c].name] != null) {
				controls[c].value = defValue[controls[c].name];
				controls[c].defaultValue = defValue[controls[c].name];
				controls[c].className += " default";
			}
		}

		// a szvegdobozoknl pedig szmoljuk s limitljuk a karaktereket
		var controls = form.getElementsByTagName("textarea");
		for (var c = 0; c < controls.length; c++) {
			controls[c].onfocus = function() { selectControl(this); }
			
			// mindekppen kell egy azonost
			controls[c].id = controls[c].id || "_textarea_" + c;
			
			// megadtak-e maximlis hosszt
			var maxLength = 0;
			if (controls[c].className) {
				var match = new RegExp(/\bmaxlen(\d{1,4})\b/).exec(controls[c].className);
				if (match != null) maxLength = parseInt(match[1]);
			}
			
			// ltrehozzuk a szmll div-et
			var counterDiv = document.createElement("div");
			counterDiv.className = "counter";
			counterDiv.innerHTML = '<span class="charnum" id="' + controls[c].id + '_charnum">0</span>';
			if (maxLength > 0)
				counterDiv.innerHTML += '/' + maxLength;
			counterDiv.innerHTML += ' karakter';
			
			// a szmllt beszrjuk a szvegdoboz mg
			controls[c].parentNode.insertBefore(counterDiv, controls[c].nextSibling)
					
			// hozzfzzk a szksges funkcit is
			controls[c].onkeyup = function() { textCounter(this); }
		}
			
		// a szvegcsoportoknl gondoskodunk a kvetkez/elz elemre ugrsrl
		var lists = form.getElementsByTagName("ul");
		for (var l = 0; l < lists.length; l++) {
			if (lists[l].className.indexOf("textgroup") > -1) {
				var elems = lists[l].getElementsByTagName("input");
				for (var e = 0; e < elems.length; e++) {
					elems[e].id = "_tg_" + l + "_" + e;
					
					elems[e].onkeypress = function(evt) {
						var charCode = (evt) ? evt.charCode : window.event.keyCode;
						if (charCode > 31 && (charCode < 48 || charCode > 57))
				            return false;
						else
					         return true;
					}
					
					elems[e].onkeyup = jumpNextElem;
				}
			}
		}
		
		// az adatok trlsekor is szrkv tesszk az alaprtelmezett rtkkel rendelkez szveges mezket
		form.onreset = function() { 
			controls = document.getElementById("registration").getElementsByTagName("input");
			for (var c = 0; c < controls.length; c++) {
				if (defValue[controls[c].name] != null) {
					controls[c].className += " default";
				}
			}
		};
	}
}

window.onload = initPage;

